// diablo2_cheditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "diablo2_chedit.h"
#include "diablo2_cheditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDiablo2_cheditDlg dialog

CDiablo2_cheditDlg::CDiablo2_cheditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiablo2_cheditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDiablo2_cheditDlg)
	m_filename = _T("");
	m_name = _T("");
	m_class = _T("");
	m_level = 0;
	m_experience = 0;
	m_strength = 0;
	m_dexterity = 0;
	m_vitality = 0;
	m_energy = 0;
	m_attackRating = 0;
	m_defense = 0;
	m_staminaCurrent = 0;
	m_staminaMax = 0;
	m_lifeCurrent = 0;
	m_lifeMax = 0;
	m_manaCurrent = 0;
	m_manaMax = 0;
	m_goldPerson = 0;
	m_goldStash = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDiablo2_cheditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiablo2_cheditDlg)
	DDX_Text(pDX, IDC_FILENAME, m_filename);
	DDX_Text(pDX, IDC_NAME, m_name);
	DDX_Text(pDX, IDC_LEVEL, m_level);
	DDX_Text(pDX, IDC_EXPERIENCE, m_experience);
	DDX_Text(pDX, IDC_STRENGTH, m_strength);
	DDX_Text(pDX, IDC_DEXTERITY, m_dexterity);
	DDX_Text(pDX, IDC_VITALITY, m_vitality);
	DDX_Text(pDX, IDC_ENERGY, m_energy);
	DDX_Text(pDX, IDC_ATTACK_RATING, m_attackRating);
	DDX_Text(pDX, IDC_STAMINA_CURRENT, m_staminaCurrent);
	DDX_Text(pDX, IDC_STAMINA_MAX, m_staminaMax);
	DDX_Text(pDX, IDC_LIFE_CURRENT, m_lifeCurrent);
	DDX_Text(pDX, IDC_LIFE_MAX, m_lifeMax);
	DDX_Text(pDX, IDC_MANA_CURRENT, m_manaCurrent);
	DDX_Text(pDX, IDC_MANA_MAX, m_manaMax);
	DDX_Text(pDX, IDC_GOLD_PERSON, m_goldPerson);
	DDX_Text(pDX, IDC_GOLD_STASH, m_goldStash);
	DDX_Text(pDX, IDC_CLASS, m_class);
	DDX_Text(pDX, IDC_DEFENSE, m_defense);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDiablo2_cheditDlg, CDialog)
	//{{AFX_MSG_MAP(CDiablo2_cheditDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FILE_LOAD, OnFileLoad)
	ON_BN_CLICKED(IDC_FILE_SAVE, OnFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiablo2_cheditDlg message handlers

BOOL CDiablo2_cheditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDiablo2_cheditDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDiablo2_cheditDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CDiablo2_cheditDlg::OnFileLoad()
{
	CFileException	cfex;
	CFileDialog		cfdlg(TRUE, "d2s", "", OFN_OVERWRITEPROMPT, "Diablo 2 save games (*.d2s)|*.d2s||", this);

	cfdlg.m_ofn.Flags |= OFN_HIDEREADONLY | OFN_LONGNAMES;
	if (cfdlg.DoModal() == IDOK)
	{
		m_filename = cfdlg.GetPathName();
		if (m_CFile.Open(m_filename, CFile::modeRead, &cfex) == FALSE)
		{
			CString		error_str;
			error_str.Format("Can't open file %s for reading!\nexception error = 0x%0X", m_filename, cfex.m_cause);
			MessageBox(error_str, "ERROR", MB_ICONSTOP);
			return;
		}

		LoadData();
		m_CFile.Close();
		UpdateData(FALSE);
		EnableControls();
	}
}


void CDiablo2_cheditDlg::OnFileSave()
{
	CFileException	cfex;
	UpdateData(TRUE);

	if (AfxMessageBox("About to save changes.  I hope you made a backup\ncopy of your SAVE directory!  Are you sure?", MB_YESNO) == IDYES)
	{
		if (m_CFile.Open(m_filename, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite, &cfex) == FALSE)
		{
			CString		error_str;
			error_str.Format("Can't open file %s for writing!\nexception error = 0x%0X", m_filename, cfex.m_cause);
			MessageBox(error_str, "ERROR", MB_ICONSTOP);
			return;
		}

		SaveData();
		m_CFile.Close();
	}
}


void CDiablo2_cheditDlg::EnableControls()
{
	GetDlgItem(IDC_FILE_SAVE)->EnableWindow(TRUE);
	GetDlgItem(IDC_FILENAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_NAME)->EnableWindow(TRUE);
//	GetDlgItem(IDC_CLASS)->EnableWindow(TRUE);
	GetDlgItem(IDC_LEVEL)->EnableWindow(TRUE);
	GetDlgItem(IDC_EXPERIENCE)->EnableWindow(TRUE);
	GetDlgItem(IDC_STRENGTH)->EnableWindow(TRUE);
	GetDlgItem(IDC_DEXTERITY)->EnableWindow(TRUE);
	GetDlgItem(IDC_VITALITY)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENERGY)->EnableWindow(TRUE);
	GetDlgItem(IDC_ATTACK_RATING)->EnableWindow(TRUE);
	GetDlgItem(IDC_DEFENSE)->EnableWindow(TRUE);
	GetDlgItem(IDC_STAMINA_CURRENT)->EnableWindow(TRUE);
	GetDlgItem(IDC_STAMINA_MAX)->EnableWindow(TRUE);
	GetDlgItem(IDC_LIFE_CURRENT)->EnableWindow(TRUE);
	GetDlgItem(IDC_LIFE_MAX)->EnableWindow(TRUE);
	GetDlgItem(IDC_MANA_CURRENT)->EnableWindow(TRUE);
	GetDlgItem(IDC_MANA_MAX)->EnableWindow(TRUE);
	GetDlgItem(IDC_GOLD_PERSON)->EnableWindow(TRUE);
	GetDlgItem(IDC_GOLD_STASH)->EnableWindow(TRUE);
}


void CDiablo2_cheditDlg::DisableControls()
{
	GetDlgItem(IDC_FILE_SAVE)->EnableWindow(FALSE);
	GetDlgItem(IDC_FILENAME)->EnableWindow(FALSE);
	GetDlgItem(IDC_NAME)->EnableWindow(FALSE);
//	GetDlgItem(IDC_CLASS)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEVEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_EXPERIENCE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STRENGTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_DEXTERITY)->EnableWindow(FALSE);
	GetDlgItem(IDC_VITALITY)->EnableWindow(FALSE);
	GetDlgItem(IDC_ENERGY)->EnableWindow(FALSE);
	GetDlgItem(IDC_ATTACK_RATING)->EnableWindow(FALSE);
	GetDlgItem(IDC_DEFENSE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STAMINA_CURRENT)->EnableWindow(FALSE);
	GetDlgItem(IDC_STAMINA_MAX)->EnableWindow(FALSE);
	GetDlgItem(IDC_LIFE_CURRENT)->EnableWindow(FALSE);
	GetDlgItem(IDC_LIFE_MAX)->EnableWindow(FALSE);
	GetDlgItem(IDC_MANA_CURRENT)->EnableWindow(FALSE);
	GetDlgItem(IDC_MANA_MAX)->EnableWindow(FALSE);
	GetDlgItem(IDC_GOLD_PERSON)->EnableWindow(FALSE);
	GetDlgItem(IDC_GOLD_STASH)->EnableWindow(FALSE);
}


void CDiablo2_cheditDlg::LoadData()
{
	m_CFile.Seek(OFFSET_NAME, CFile::begin);
	char *p = m_name.GetBuffer(LENGTH_NAME + 1);	// Length is 15 in the file, but add 1 for NULL terminator
	m_CFile.Read(p, LENGTH_NAME);
	m_name.ReleaseBuffer();

/*
	m_CFile.Seek(OFFSET_CLASS, CFile::begin);
	m_CFile.Read(&m_class, LENGTH_CLASS);
*/

	m_CFile.Seek(OFFSET_LEVEL, CFile::begin);
	m_CFile.Read(&m_level, LENGTH_LEVEL);

	m_CFile.Seek(OFFSET_EXPERIENCE, CFile::begin);
	m_CFile.Read(&m_experience, LENGTH_EXPERIENCE);

	m_CFile.Seek(OFFSET_STRENGTH, CFile::begin);
	m_CFile.Read(&m_strength, LENGTH_STRENGTH);

	m_CFile.Seek(OFFSET_DEXTERITY, CFile::begin);
	m_CFile.Read(&m_dexterity, LENGTH_DEXTERITY);

	m_CFile.Seek(OFFSET_VITALITY, CFile::begin);
	m_CFile.Read(&m_vitality, LENGTH_VITALITY);

	m_CFile.Seek(OFFSET_ENERGY, CFile::begin);
	m_CFile.Read(&m_energy, LENGTH_ENERGY);

	m_CFile.Seek(OFFSET_ATTACK_RATING, CFile::begin);
	m_CFile.Read(&m_attackRating, LENGTH_ATTACK_RATING);

	m_CFile.Seek(OFFSET_DEFENSE, CFile::begin);
	m_CFile.Read(&m_defense, LENGTH_DEFENSE);

	m_CFile.Seek(OFFSET_STAMINA_CURRENT, CFile::begin);
	m_CFile.Read(&m_staminaCurrent, LENGTH_STAMINA_CURRENT);

	m_CFile.Seek(OFFSET_STAMINA_MAX, CFile::begin);
	m_CFile.Read(&m_staminaMax, LENGTH_STAMINA_MAX);

	m_CFile.Seek(OFFSET_LIFE_CURRENT, CFile::begin);
	m_CFile.Read(&m_lifeCurrent, LENGTH_LIFE_CURRENT);

	m_CFile.Seek(OFFSET_LIFE_MAX, CFile::begin);
	m_CFile.Read(&m_lifeMax, LENGTH_LIFE_MAX);

	m_CFile.Seek(OFFSET_MANA_CURRENT, CFile::begin);
	m_CFile.Read(&m_manaCurrent, LENGTH_MANA_CURRENT);

	m_CFile.Seek(OFFSET_MANA_MAX, CFile::begin);
	m_CFile.Read(&m_manaMax, LENGTH_MANA_MAX);

	m_CFile.Seek(OFFSET_GOLD_PERSON, CFile::begin);
	m_CFile.Read(&m_goldPerson, LENGTH_GOLD_PERSON);

	m_CFile.Seek(OFFSET_GOLD_STASH, CFile::begin);
	m_CFile.Read(&m_goldStash, LENGTH_GOLD_STASH);
}


void CDiablo2_cheditDlg::SaveData()
{
	m_CFile.Seek(OFFSET_NAME, CFile::begin);
	char *p = m_name.GetBuffer(LENGTH_NAME + 1);	// Length is 15 in the file, but add 1 for NULL terminator
	m_CFile.Write(p, LENGTH_NAME);
	m_name.ReleaseBuffer();

/*
	m_CFile.Seek(OFFSET_CLASS, CFile::begin);
	m_CFile.Write(&m_class, LENGTH_CLASS);
*/

	m_CFile.Seek(OFFSET_LEVEL, CFile::begin);
	m_CFile.Write(&m_level, LENGTH_LEVEL);

	m_CFile.Seek(OFFSET_EXPERIENCE, CFile::begin);
	m_CFile.Write(&m_experience, LENGTH_EXPERIENCE);

	m_CFile.Seek(OFFSET_STRENGTH, CFile::begin);
	m_CFile.Write(&m_strength, LENGTH_STRENGTH);

	m_CFile.Seek(OFFSET_DEXTERITY, CFile::begin);
	m_CFile.Write(&m_dexterity, LENGTH_DEXTERITY);

	m_CFile.Seek(OFFSET_VITALITY, CFile::begin);
	m_CFile.Write(&m_vitality, LENGTH_VITALITY);

	m_CFile.Seek(OFFSET_ENERGY, CFile::begin);
	m_CFile.Write(&m_energy, LENGTH_ENERGY);

	m_CFile.Seek(OFFSET_ATTACK_RATING, CFile::begin);
	m_CFile.Write(&m_attackRating, LENGTH_ATTACK_RATING);

	m_CFile.Seek(OFFSET_DEFENSE, CFile::begin);
	m_CFile.Write(&m_defense, LENGTH_DEFENSE);

	m_CFile.Seek(OFFSET_STAMINA_CURRENT, CFile::begin);
	m_CFile.Write(&m_staminaCurrent, LENGTH_STAMINA_CURRENT);

	m_CFile.Seek(OFFSET_STAMINA_MAX, CFile::begin);
	m_CFile.Write(&m_staminaMax, LENGTH_STAMINA_MAX);

	m_CFile.Seek(OFFSET_LIFE_CURRENT, CFile::begin);
	m_CFile.Write(&m_lifeCurrent, LENGTH_LIFE_CURRENT);

	m_CFile.Seek(OFFSET_LIFE_MAX, CFile::begin);
	m_CFile.Write(&m_lifeMax, LENGTH_LIFE_MAX);

	m_CFile.Seek(OFFSET_MANA_CURRENT, CFile::begin);
	m_CFile.Write(&m_manaCurrent, LENGTH_MANA_CURRENT);

	m_CFile.Seek(OFFSET_MANA_MAX, CFile::begin);
	m_CFile.Write(&m_manaMax, LENGTH_MANA_MAX);

	m_CFile.Seek(OFFSET_GOLD_PERSON, CFile::begin);
	m_CFile.Write(&m_goldPerson, LENGTH_GOLD_PERSON);

	m_CFile.Seek(OFFSET_GOLD_STASH, CFile::begin);
	m_CFile.Write(&m_goldStash, LENGTH_GOLD_STASH);
}
